> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pnbr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Stage existing records

> Check existing nodes or edges out of the graph into a workspace for update or delete.

**Operation ID:** `http.graph.workspaces.hydrate`

```http theme={null}
POST /v1/orgs/{org}/projects/{project}/graph/workspaces/{ws}/hydrate
```


## OpenAPI

````yaml openapi.json POST /v1/orgs/{org}/projects/{project}/graph/workspaces/{ws}/hydrate
openapi: 3.1.0
info:
  title: Penumbra API
  version: v1
  description: >-
    HTTP reference for Files, search, extraction, reviews, Graph, Shapes and
    sharing.
servers:
  - url: https://api.pnbr.io
    description: Penumbra API
security: []
paths:
  /v1/orgs/{org}/projects/{project}/graph/workspaces/{ws}/hydrate:
    post:
      tags:
        - Review workspaces
      summary: Stage existing records
      description: >-
        Check existing nodes or edges out of the graph into a workspace for
        update or delete.


        Product guidance: [Workspace](/concepts/workspace).
      operationId: http.graph.workspaces.hydrate
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: project
          in: path
          required: true
          schema:
            type: string
        - name: ws
          in: path
          required: true
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/http_graph_workspaces_hydrate_request'
      responses:
        2XX:
          description: Success.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/http_graph_workspaces_hydrate_response'
      security:
        - bearerAuth: []
components:
  schemas:
    http_graph_workspaces_hydrate_request:
      type: object
      properties:
        idempotency_key:
          type: string
          minLength: 1
          maxLength: 200
        nodes:
          maxItems: 100
          type: array
          items:
            description: >-
              Node id, or a node name. A unique exact or partial name resolves
              only after a complete bounded canonical scan; ambiguity or an
              incomplete scan requires an exact id from the candidates or graph
              reads.
            type: string
            minLength: 1
            maxLength: 1024
        edges:
          description: Edge ids to hydrate.
          maxItems: 100
          type: array
          items:
            type: string
            format: uuid
            pattern: >-
              ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
        intent:
          default: update
          type: string
          enum:
            - update
            - delete
      additionalProperties: false
    http_graph_workspaces_hydrate_response:
      type: object
      properties:
        data:
          type: object
          properties:
            workspace:
              type: object
              properties:
                id:
                  type: string
                creation_origin:
                  type: string
                name:
                  type: string
                description:
                  anyOf:
                    - type: string
                    - type: 'null'
                status:
                  type: string
                  enum:
                    - open
                    - submitted
                    - applied
                    - closed
                revision:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                item_count:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                shape:
                  anyOf:
                    - type: object
                      properties:
                        shape_id:
                          type: string
                        artifact_digest:
                          type: string
                      required:
                        - shape_id
                        - artifact_digest
                      additionalProperties: {}
                    - type: 'null'
                bindings:
                  type: array
                  items:
                    type: object
                    properties:
                      shape_id:
                        type: string
                      artifact_digest:
                        type: string
                    required:
                      - shape_id
                      - artifact_digest
                    additionalProperties: {}
                bridge_set:
                  anyOf:
                    - type: object
                      properties:
                        digest:
                          type: string
                        declaration_count:
                          type: integer
                          minimum: -9007199254740991
                          maximum: 9007199254740991
                      required:
                        - digest
                        - declaration_count
                      additionalProperties: {}
                    - type: 'null'
                created_at:
                  type: string
                updated_at:
                  type: string
                applied_at:
                  anyOf:
                    - type: string
                    - type: 'null'
                replaced_by:
                  type: string
              required:
                - id
                - creation_origin
                - name
                - description
                - status
                - revision
                - item_count
                - shape
                - bindings
                - bridge_set
                - created_at
                - updated_at
                - applied_at
              additionalProperties: {}
            staged:
              type: array
              items:
                oneOf:
                  - type: object
                    properties:
                      kind:
                        type: string
                        const: entity
                      handle:
                        type: string
                      ref:
                        anyOf:
                          - type: string
                          - type: 'null'
                      type_name:
                        type: string
                      name:
                        type: string
                      properties:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties: {}
                      binding:
                        type: object
                        properties:
                          shape_id:
                            type: string
                          artifact_digest:
                            type: string
                        required:
                          - shape_id
                          - artifact_digest
                        additionalProperties: {}
                      evidence:
                        type: array
                        items:
                          type: object
                          properties: {}
                          additionalProperties: {}
                      created_at:
                        type: string
                    required:
                      - kind
                      - handle
                      - ref
                      - type_name
                      - name
                      - properties
                      - binding
                      - evidence
                      - created_at
                    additionalProperties: {}
                  - type: object
                    properties:
                      kind:
                        type: string
                        const: relationship
                      handle:
                        type: string
                      ref:
                        anyOf:
                          - type: string
                          - type: 'null'
                      edge_type:
                        type: string
                      source:
                        type: object
                        properties: {}
                        additionalProperties: {}
                      target:
                        type: object
                        properties: {}
                        additionalProperties: {}
                      properties:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties: {}
                      evidence:
                        type: array
                        items:
                          type: object
                          properties: {}
                          additionalProperties: {}
                      created_at:
                        type: string
                    required:
                      - kind
                      - handle
                      - ref
                      - edge_type
                      - source
                      - target
                      - properties
                      - evidence
                      - created_at
                    additionalProperties: {}
                  - type: object
                    properties:
                      kind:
                        type: string
                        const: hydrated_node
                      handle:
                        type: string
                      node_id:
                        type: string
                      witness_revision:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      intent:
                        type: string
                        enum:
                          - update
                          - delete
                      snapshot:
                        type: object
                        properties: {}
                        additionalProperties: {}
                      evidence:
                        type: array
                        items:
                          type: object
                          properties: {}
                          additionalProperties: {}
                      created_at:
                        type: string
                    required:
                      - kind
                      - handle
                      - node_id
                      - witness_revision
                      - intent
                      - snapshot
                      - evidence
                      - created_at
                    additionalProperties: {}
                  - type: object
                    properties:
                      kind:
                        type: string
                        const: hydrated_edge
                      handle:
                        type: string
                      edge_id:
                        type: string
                      witness_revision:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      intent:
                        type: string
                        enum:
                          - update
                          - delete
                      snapshot:
                        type: object
                        properties: {}
                        additionalProperties: {}
                      evidence:
                        type: array
                        items:
                          type: object
                          properties: {}
                          additionalProperties: {}
                      created_at:
                        type: string
                    required:
                      - kind
                      - handle
                      - edge_id
                      - witness_revision
                      - intent
                      - snapshot
                      - evidence
                      - created_at
                    additionalProperties: {}
            notes:
              type: array
              items:
                type: string
          required:
            - workspace
            - staged
            - notes
          additionalProperties: {}
      required:
        - data
      additionalProperties: false
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.